OGRE-Next: Ogre::ManualObject Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
Ogre::ManualObject Class Reference

`#include <OgreManualObject2.h>`

Inheritance diagram for Ogre::ManualObject:
[legend]

## Classes
class | ManualObjectSection
| Built, renderable section of geometry. More...

## Public Types
typedef vector< ManualObjectSection * >::type | SectionList
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray

## Public Member Functions
| ManualObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager)
| ~ManualObject () override
void | _releaseManualHardwareResources () override
| Notifies the movable object that hardware resources were lost.
virtual_l1 void | begin (const String &datablockName, OperationType opType=OT_TRIANGLE_LIST)
| Start defining a part of the object.
virtual_l1 void | beginUpdate (size_t sectionIndex)
| Start the definition of an update to a part of the object.
virtual_l1 void | clear ()
| Completely clear the contents of the object.
virtual_l1 void | colour (const ColourValue &col)
| Add a vertex diffuse colour to a vertex.
virtual_l1 void | colour (Real r, Real g, Real b, Real a=1.0f)
| Add a vertex diffuse colour to a vertex.
virtual_l1 MeshPtr | convertToMesh (const String &meshName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, bool buildShadowMapBuffers=true)
| Convert this object to a Mesh.
size_t | currentIndexCount ()
| Get the current count of indices when building a new buffer.
size_t | currentVertexCount ()
| Get the current count of vertices when building a new buffer.
virtual_l1 ManualObjectSection * | end ()
| Finish defining the object and compile the final renderable version.
virtual_l1 void | estimateIndexCount (size_t icount)
| Estimate the number of indices ahead of time.
virtual_l1 void | estimateVertexCount (size_t vcount)
| Estimate the number of vertices ahead of time.
virtual_l1 size_t | getCurrentIndexCount () const
| Get the number of indices in the section currently being defined (returns 0 if no section is in progress).
virtual_l1 size_t | getCurrentVertexCount () const
| Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).
const String & | getMovableType () const override
| Returns the type name of this object.
unsigned int | getNumSections () const
| Retrieves the number of ManualObjectSection objects making up this ManualObject.
ManualObjectSection * | getSection (const Ogre::String &name) const
| Gets a pointer to a previously named ManualObjectSection (via ManualObjectSection::setName).
ManualObjectSection * | getSection (unsigned int index) const
| Gets a pointer to a ManualObjectSection, i.e.
virtual_l1 void | index (uint32 idx)
| Add a vertex index to construct faces / lines / points.
virtual_l1 void | line (uint32 i1, uint32 i2)
| Add a set of 2 vertex indices to construct a line; this is a shortcut to calling index() 2 times.
virtual_l1 void | normal (const Vector3 &norm)
| Add a vertex normal to the current vertex.
virtual_l1 void | normal (Real x, Real y, Real z)
| Add a vertex normal to the current vertex.
virtual_l1 void | position (const Vector3 &pos)
| Add a vertex position, starting a new vertex at the same time.
virtual_l1 void | position (Real x, Real y, Real z)
| Add a vertex position, starting a new vertex at the same time.
virtual_l1 void | quad (uint32 i1, uint32 i2, uint32 i3, uint32 i4)
| Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.
void | removeSection (unsigned int idx)
| Removes the section with given index.
void | setDatablock (size_t subIndex, const String &name)
| Alter the material for a subsection of this object after it has been specified.
virtual_l1 void | specular (const ColourValue &col)
| Add a vertex specular colour to a vertex.
virtual_l1 void | specular (Real r, Real g, Real b, Real a=1.0f)
| Add a vertex specular colour to a vertex.
virtual_l1 void | tangent (const Vector3 &tan)
| Add a vertex tangent to the current vertex.
virtual_l1 void | tangent (Real x, Real y, Real z)
| Add a vertex tangent to the current vertex.
virtual_l1 void | textureCoord (const Vector2 &uv)
| Add a texture coordinate to the current vertex.
virtual_l1 void | textureCoord (const Vector3 &uvw)
| Add a texture coordinate to the current vertex.
virtual_l1 void | textureCoord (const Vector4 &xyzw)
| Add a texture coordinate to the current vertex.
virtual_l1 void | textureCoord (Real u)
| Add a texture coordinate to the current vertex.
virtual_l1 void | textureCoord (Real u, Real v)
| Add a texture coordinate to the current vertex.
virtual_l1 void | textureCoord (Real u, Real v, Real w)
| Add a texture coordinate to the current vertex.
virtual_l1 void | textureCoord (Real x, Real y, Real z, Real w)
| Add a texture coordinate to the current vertex.
virtual_l1 void | triangle (uint32 i1, uint32 i2, uint32 i3)
| Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Member Typedef Documentation

## ◆ SectionList

typedef vector<ManualObjectSection*>::type Ogre::ManualObject::SectionList

## Constructor & Destructor Documentation

## ◆ ManualObject()

Ogre::ManualObject::ManualObject | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager )

## ◆ ~ManualObject()

Ogre::ManualObject::~ManualObject | ( |  | ) |
| override

## Member Function Documentation

## ◆ _releaseManualHardwareResources()

void Ogre::ManualObject::_releaseManualHardwareResources | ( |  | ) |
| inlineoverridevirtual

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

References clear().

## ◆ begin()

virtual_l1 void Ogre::ManualObject::begin | ( | const String & | datablockName,
|  | OperationType | opType = OT_TRIANGLE_LIST )

Start defining a part of the object.

Remarks
  Each time you call this method, you start a new section of the object with its own material and potentially its own type of rendering operation (triangles, points or lines for example).

Parameters

  datablockName | The name of the datablock to render this part of the object with.
  opType | The type of operation to use to render.

References Ogre::OT_TRIANGLE_LIST, and virtual_l1.

## ◆ beginUpdate()

virtual_l1 void Ogre::ManualObject::beginUpdate | ( | size_t | sectionIndex | ) |

Start the definition of an update to a part of the object.

Remarks
  Using this method, you can update an existing section of the object efficiently. You do not have the option of changing the operation type obviously, since it must match the one that was used before.

Note
  Changing size of the sections is not supported, you are expected to supply the same amount of data with the same layout when updating. If you want to change the data layout, call clear() and create new sections with begin().

Parameters

  sectionIndex | The index of the section you want to update. The first call to begin() would have created section 0, the second section 1, etc.

References virtual_l1.

## ◆ clear()

virtual_l1 void Ogre::ManualObject::clear | ( |  | ) |

Completely clear the contents of the object.

Remarks
  Clearing the contents of this object and rebuilding from scratch is not the optimal way to manage dynamic vertex data, since the buffers are recreated. If you want to keep the same structure but update the content within that structure, use beginUpdate() instead of clear() begin(). However if you do want to modify the structure from time to time you can do so by clearing and re-specifying the data.

References virtual_l1.

Referenced by _releaseManualHardwareResources().

## ◆ colour() [1/2]

virtual_l1 void Ogre::ManualObject::colour | ( | const ColourValue & | col | ) |

Add a vertex diffuse colour to a vertex.

References virtual_l1.

## ◆ colour() [2/2]

virtual_l1 void Ogre::ManualObject::colour | ( | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = 1.0f )

Add a vertex diffuse colour to a vertex.

Parameters

  r,g,b,a | Colour components expressed as floating point numbers from 0-1

References virtual_l1.

## ◆ convertToMesh()

virtual_l1 MeshPtr Ogre::ManualObject::convertToMesh | ( | const String & | meshName,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME,
|  | bool | buildShadowMapBuffers = true )

Convert this object to a Mesh.

Remarks
  After you've finished building this object, you may convert it to a Mesh if you want in order to be able to create many instances of it in the world (via Item). This is optional, since this instance can be directly attached to a SceneNode itself, but of course only one instance of it can exist that way.

Note
  Only objects which use indexed geometry may be converted to a mesh.

Parameters

  meshName | The name to give the mesh
  groupName | The resource group to create the mesh in
  buildShadowMapBuffers | True to create an optimized copy of the vertex buffers for efficient shadow mapping.

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ currentIndexCount()

size_t Ogre::ManualObject::currentIndexCount | ( |  | ) |

Get the current count of indices when building a new buffer.

Returns
  Index count

## ◆ currentVertexCount()

size_t Ogre::ManualObject::currentVertexCount | ( |  | ) |

Get the current count of vertices when building a new buffer.

Returns
  Vertex count

## ◆ end()

virtual_l1 ManualObjectSection * Ogre::ManualObject::end | ( |  | ) |

Finish defining the object and compile the final renderable version.

Note
  Will return a pointer to the finished section or NULL if the section was discarded (i.e. has zero vertices/indices).

References virtual_l1.

## ◆ estimateIndexCount()

virtual_l1 void Ogre::ManualObject::estimateIndexCount | ( | size_t | icount | ) |

Estimate the number of indices ahead of time.

Remarks
  Calling this helps to avoid memory reallocation when you first define indices with begin() -> end() sequence.

References virtual_l1.

## ◆ estimateVertexCount()

virtual_l1 void Ogre::ManualObject::estimateVertexCount | ( | size_t | vcount | ) |

Estimate the number of vertices ahead of time.

Remarks
  Calling this helps to avoid memory reallocation when you first define indices with begin() -> end() sequence.

References virtual_l1.

## ◆ getCurrentIndexCount()

virtual_l1 size_t Ogre::ManualObject::getCurrentIndexCount | ( |  | ) | const

Get the number of indices in the section currently being defined (returns 0 if no section is in progress).

References virtual_l1.

## ◆ getCurrentVertexCount()

virtual_l1 size_t Ogre::ManualObject::getCurrentVertexCount | ( |  | ) | const

Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).

References virtual_l1.

## ◆ getMovableType()

const String & Ogre::ManualObject::getMovableType | ( |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getNumSections()

unsigned int Ogre::ManualObject::getNumSections | ( |  | ) | const

Retrieves the number of ManualObjectSection objects making up this ManualObject.

## ◆ getSection() [1/2]

ManualObjectSection * Ogre::ManualObject::getSection | ( | const Ogre::String & | name | ) | const

Gets a pointer to a previously named ManualObjectSection (via ManualObjectSection::setName).

## ◆ getSection() [2/2]

ManualObjectSection * Ogre::ManualObject::getSection | ( | unsigned int | index | ) | const

Gets a pointer to a ManualObjectSection, i.e.

a part of a ManualObject.

References index().

## ◆ index()

virtual_l1 void Ogre::ManualObject::index | ( | uint32 | idx | ) |

Add a vertex index to construct faces / lines / points.

Remarks
  You will have to call this 3 times for each face for a triangle list, or use the alternative 3-parameter version. Other operation types require different numbers of indexes,

See also
  OperationType.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  idx | A vertex index from 0 to 4294967295.

References virtual_l1.

Referenced by Ogre::Volume::MeshBuilder::addCubeToManualObject(), and getSection().

## ◆ line()

virtual_l1 void Ogre::ManualObject::line | ( | uint32 | i1,
|  | uint32 | i2 )

Add a set of 2 vertex indices to construct a line; this is a shortcut to calling index() 2 times.

It is only valid for line lists.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2 | 2 vertex indices from 0 to 4294967295 defining a face.

References virtual_l1.

## ◆ normal() [1/2]

virtual_l1 void Ogre::ManualObject::normal | ( | const Vector3 & | norm | ) |

Add a vertex normal to the current vertex.

Remarks
  Vertex normals are most often used for dynamic lighting, and their components should be normalised.

References virtual_l1.

## ◆ normal() [2/2]

virtual_l1 void Ogre::ManualObject::normal | ( | Real | x,
|  | Real | y,
|  | Real | z )

Add a vertex normal to the current vertex.

Remarks
  Vertex normals are most often used for dynamic lighting, and their components should be normalised.

References virtual_l1.

## ◆ position() [1/2]

virtual_l1 void Ogre::ManualObject::position | ( | const Vector3 & | pos | ) |

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

References virtual_l1.

Referenced by Ogre::Volume::MeshBuilder::addCubeToManualObject().

## ◆ position() [2/2]

virtual_l1 void Ogre::ManualObject::position | ( | Real | x,
|  | Real | y,
|  | Real | z )

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

References virtual_l1.

## ◆ quad()

virtual_l1 void Ogre::ManualObject::quad | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3,
|  | uint32 | i4 )

Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.

It's only valid for triangle list operations.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3,i4 | 4 vertex indices from 0 to 4294967295 defining a quad.

References virtual_l1.

## ◆ removeSection()

void Ogre::ManualObject::removeSection | ( | unsigned int | idx | ) |

Removes the section with given index.

Parameters

  idx | Index of section to remove.

## ◆ setDatablock()

void Ogre::ManualObject::setDatablock | ( | size_t | subIndex,
|  | const String & | name )

Alter the material for a subsection of this object after it has been specified.

Remarks
  You specify the datablock to use on a section of this object during the call to begin(), however if you want to change the datablock afterwards you can do so by calling this method.

Note
  This function is a shortcut of calling Renderable::setDatablock() on all sections in this manual object. If you want to set a datablock with pointer instead of ID string, you need to get the section and call the appropriate function.

Parameters

  subIndex | The index of the subsection to alter
  name | The name of the new datablock to use

References virtual_l1.

## ◆ specular() [1/2]

virtual_l1 void Ogre::ManualObject::specular | ( | const ColourValue & | col | ) |

Add a vertex specular colour to a vertex.

References virtual_l1.

## ◆ specular() [2/2]

virtual_l1 void Ogre::ManualObject::specular | ( | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = 1.0f )

Add a vertex specular colour to a vertex.

Parameters

  r,g,b,a | Colour components expressed as floating point numbers from 0-1

References virtual_l1.

## ◆ tangent() [1/2]

virtual_l1 void Ogre::ManualObject::tangent | ( | const Vector3 & | tan | ) |

Add a vertex tangent to the current vertex.

Remarks
  Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

References virtual_l1.

## ◆ tangent() [2/2]

virtual_l1 void Ogre::ManualObject::tangent | ( | Real | x,
|  | Real | y,
|  | Real | z )

Add a vertex tangent to the current vertex.

Remarks
  Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

References virtual_l1.

## ◆ textureCoord() [1/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | const Vector2 & | uv | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ textureCoord() [2/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | const Vector3 & | uvw | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ textureCoord() [3/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | const Vector4 & | xyzw | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ textureCoord() [4/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | u | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ textureCoord() [5/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | u,
|  | Real | v )

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ textureCoord() [6/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | u,
|  | Real | v,
|  | Real | w )

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ textureCoord() [7/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | Real | w )

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References virtual_l1.

## ◆ triangle()

virtual_l1 void Ogre::ManualObject::triangle | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3 )

Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.

It is only valid for triangle lists.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3 | 3 vertex indices from 0 to 4294967295 defining a face.

References virtual_l1.

The documentation for this class was generated from the following file:

- OgreManualObject2.h